#ifndef VFD_H
#define VFD_H

/*
Copyright (c) 2008, Michael Odenwald
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer 
   in the documentation and/or other materials provided with the distribution.
 * Neither the name of the <ORGANIZATION> nor the names of its contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
#include <avr/pgmspace.h>

/* VFD definition */
#define VFD_VERSION "VFD Lib 20081231"	
#define VFD_ROWS	2
#define VFD_COLUMNS	20
	
#define VFD_BS_NONE_DESTRUCTIVE	0	
#define VFD_BS_DESTRUCTIVE		1
	
/* definition of the VFD low level callback function */	
int (*vfd_putc) (uint8_t c);

/* definition of the function prototypes */
void vfd_puts (char *s);
void vfd_puts_p(const char *progmem_s);
void vfd_version(void);
void vfd_euro(void);
void vfd_linefeed(void);
void vfd_hsm(void);
void vfd_bs(uint8_t des);
void vfd_intfont(void);
void vfd_katafont(void);
void vfd_clrscr(void);
void vfd_cursor_on(void);
void vfd_cursor_on_blinking(void);
void vfd_cursor_on_char(void);
void vfd_cursor_off(void);
int  vfd_gotoxy(uint8_t x, uint8_t y);
int  vfd_init(int (*f) (uint8_t c));

/*
** macro for storing strings in program memory (saves RAM)
*/
#ifndef P
#define P(s) ({static const char c[] __attribute__ ((progmem)) = s;c;})
#endif
#define vfd_puts_P(__s)         vfd_puts_p(P(__s))

#endif /* VFD_H */
